; Add check with DrWeb in Opera, by A.Ruzanov
; 09.12.2007


#NoTrayIcon

$MP = 'Select a Opera folder in the list below, then click OK.'
$MOK = 'Setup has finished installing "Check with Dr.Web Online" in Opera.'
$IMenu = '"Check with Dr.Web Online"'

Select
	Case @OSLang = 0419
		$MP = "    Opera"
		$MOK = "  "
		$IMenu = '"Проверить с помощью Dr.Web Online"'
		
	Case StringInStr("0407,0807,0c07,1007,1407", @OSLang)
		$MP = "Whlen Sie Ihr Opera-Installationsverzeichnis aus und klicken Sie auf OK."
		
	Case StringInStr("040a,080a,0c0a,100a,140a,180a,1c0a,200a,240a,280a,2c0a,300a,340a,380a,3c0a,400a,440a,480a,4c0a,500a", @OSLang)
		$MP = "Seleccionar la carpeta de Opera de la siguiente lista, despus click OK."
EndSelect

$StartDir = @ScriptDir
If Not FileExists($StartDir & "\opera.exe") Then
	$StartDirArr = StringSplit(StringLower(RegRead("HKEY_CURRENT_USER\Software\Opera Software", "Last CommandLine v2")), "\opera.exe ", 1)
	If IsArray($StartDirArr) Then $StartDir = $StartDirArr[1]
EndIf
If Not FileExists($StartDir & "\opera.exe") Then $StartDir = RegRead("HKEY_CURRENT_USER\Software\Opera Software", "Last Directory3")
If Not FileExists($StartDir & "\opera.exe") Then $StartDir = ""

$OperaDir = FileSelectFolder($MP, "", 0, $StartDir)
If @error Then Exit

If IniRead($OperaDir & "\OperaDef6.ini", "System", "Multi User", "1") = 1 Then
	$VarOpDir = StringSplit($OperaDir, "\")
	$NameDir = $VarOpDir[UBound($VarOpDir) - 1]
	$VarMenu = @AppDataDir & "\opera\" & $NameDir & "\profile\menu\"
	$VarOpera6 = @AppDataDir & "\opera\" & $NameDir & "\profile\opera6.ini"
Else
	$VarMenu = $OperaDir & "\profile\menu\"
	$VarOpera6 = $OperaDir & "\profile\opera6.ini"
EndIf

$VarDefMenu = $OperaDir & "\defaults\standard_menu.ini"

$VarSearchM = FileFindFirstFile($VarMenu & "*.ini")
If $VarSearchM = -1 Then
	$VarOperaMenu = $VarDefMenu
	Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
Else
	While 1
		$VarOperaMenu = $VarMenu & FileFindNextFile($VarSearchM)
		If @error Then ExitLoop
		Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
	WEnd
	FileClose($VarSearchM)
EndIf

MsgBox(64, "   Dr.Web Online", $MOK, 10)
Exit

Func Transfer($Home)
	$VarBTM = IniReadSection($VarOperaMenu, $Home)
	If @error Then
		$VarHNDL = FileOpen($VarOperaMenu, 1)
		$VarDefHNDL = FileOpen($VarDefMenu, 0)
		$BTM = ""
		While $BTM <> "[" & $Home & "]"
			$BTM = FileReadLine($VarDefHNDL)
		WEnd
		
		$BTM = @CRLF & $BTM
		
		Do
			FileWriteLine($VarHNDL, $BTM)
			$BTM = FileReadLine($VarDefHNDL)
		Until StringLeft($BTM, 1) = "[" Or StringLeft($BTM, 2) = ";["
		FileClose($VarHNDL)
		FileClose($VarDefHNDL)
	EndIf
EndFunc   ;==>Transfer

Func Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
	$VarBak = $VarOperaMenu & "_1.bak"
	If FileExists($VarBak) Then
		$Num = 2
		While FileExists($VarOperaMenu & "_" & $Num & ".bak")
			$Num = $Num + 1
		WEnd
		$VarBak = $VarOperaMenu & "_" & $Num & ".bak"
	EndIf
	
	FileCopy($VarOperaMenu, $VarBak, 1)
	
	Transfer("Link Popup Menu")
	Transfer("Image Link Popup Menu")
	Transfer("Hotclick Popup Menu")
	Transfer("Document Popup Menu")
	
	
	IniWrite($VarOperaMenu, "Link Popup Menu", 'Item, ' & $IMenu, '"Go to Page, "javascript: void(window.open(''http://online.drweb.com/result?url=''+escape(''%l''),''DrWeb_%l'',''width=640,height=400,left=100,top=100,scrollbars=yes,location=no''));",,,"drweb" "')
	
	IniWrite($VarOperaMenu, "Image Link Popup Menu", 'Item, ' & $IMenu, '"Go to Page, "javascript: void(window.open(''http://online.drweb.com/result?url=''+escape(''%l''),''DrWeb_%l'',''width=640,height=400,left=100,top=100,scrollbars=yes,location=no''));",,,"drweb" "')
	
	IniWrite($VarOperaMenu, "Hotclick Popup Menu", 'Item, ' & $IMenu, '"Go to Page, "javascript: (function(){var reh=/^_?[hх].{2}[pп]:\/\//i;var ref=/^_?[fф].{1}[pп]:\/\//i;var refo = /^_?ftp\./i; var hrefurl=document.getSelection().replace(reh,''http:\/\/'').replace(ref,''ftp:\/\/'').replace(refo,''ftp:\/\/ftp\.''); if (hrefurl.indexOf(''http:\/\/'')==-1 && hrefurl.indexOf(''ftp:\/\/'')==-1){hrefurl=''http:\/\/''+hrefurl};window.open(''http://online.drweb.com/result?url=''+escape(hrefurl),''DrWeb_''+hrefurl,''width=640,height=400,left=100,top=100,scrollbars=yes,location=no'');})()",,,"drweb" "')
	
	IniWrite($VarOperaMenu, "Document Popup Menu", 'Item, ' & $IMenu, '"Go to Page, "javascript: void(window.open(''http://online.drweb.com/result?url=''+escape(location),''DrWeb_''+location,''width=640,height=400,left=200,top=100,scrollbars=yes,location=no''));",,,"drweb" "')
	
	
EndFunc   ;==>Correct
